#ifndef _EVAL_CPP_H_
#define _EVAL_CPP_H_

#include <stdlib.h> 
#include <iostream>
#include "base.h"
#include "mtrand.h"
#include "select.h"
#include "gene.h"

class Evaluation
{
	static int pop_num;
	mutable MTRand mtrand;
	static int obj_num;
	static int length;
	static int func_num;
public:
	//	Evaluation();
	// ~Evaluation();
	Select select;
        inline double genrand() const {return mtrand.genrand();}
	inline int genrand_int(const int& n) const {return mtrand.genrand_int(n);}
	inline void set_pop_num(const int& x)	{pop_num=x;}
	inline int get_pop_num()	{return pop_num;}
	inline void set_length(const int& x)	{length=x;}
	inline int get_length()	{return length;}
	inline void set_obj_num(const int& x) {obj_num=x;}
	inline int get_obj_num() {return obj_num;}
	inline void set_func_num(const int& x) {func_num=x;}
	inline int get_func_num() {return func_num;}
	double cover_rate(Gene **,const int&);
	double coverage(Gene **,const int&);
	double total_size(Gene **,const int&); 
	//	double absolution(Gene **,const int&);
};

#endif  //_EVAL_CPP_H

