//-------------------------------------------------------------------
// FILENAME    : func.cpp
// DESCRIPTION : Function 
//-------------------------------------------------------------------
#include <stdio.h>
#include <iostream>
#include <math.h>
#include <sys/time.h>
#include "base.h"
#include "gene.h"
#include "pop.h"
#include "func.h"

int Func::obj_num=2;
int Func::plan_num=5;
int Func::func_number=0;
int Func::func_count=0;
int Func::chromosome_length=10;
double Func::sleep_time=0.001;

Func::Func()
{
	func_count=0;
}

Func::Func(const Func& f)
{
  func_count=0;
}

void Func::init_Func(const int& x)
{
	func_number = x;
}



void Func::sleep()
{
  sleep(sleep_time);
}

void Func::sleep(double _sleep_time)
{
  double start,end;
  struct timeval tv1,tv2;
  struct timezone tz;

  gettimeofday(&tv1,&tz);
  start=(double)tv1.tv_sec+((double)tv1.tv_usec*(1.0e-6));
  
  while(1){
    gettimeofday(&tv2,&tz);
    end=(double)tv2.tv_sec+((double)tv2.tv_usec*(1.0e-6));
    if((end-start)>_sleep_time)
      break;
  }
}

