//-------------------------------------------------------------------
// FILENAME    : func.h
// DESCRIPTION : Function 
//-------------------------------------------------------------------
#ifndef _FUNC_CPP_H_
#define _FUNC_CPP_H_

#include <iostream>
#include <stdlib.h>
#include "base.h"

#define SAFE 1
#define OUT 0

class Gene;
class Pop;

class Func
{
protected:
	int pop_num;
	static int obj_num;
	static int func_number;
	static int plan_num;
	static int chromosome_length;
	static int func_count;
	static double sleep_time;
public:
	Func();
	Func(const Func&);
	virtual ~Func() {};
	virtual void init_Func(const int&);
	inline int get_plan_num()       {return plan_num;}
	inline void set_plan_num(const int &x)	{plan_num=x;}
	inline double get_sleep_time()       {return sleep_time;}
	inline void set_sleep_time(const double &x)	{sleep_time=x;}
	inline int get_pop_num()	{return pop_num;}
	inline void set_pop_num(const int &x)	{pop_num=x;}
	inline int get_obj_num()	{return obj_num;}
	inline void set_obj_num(int &x)	{obj_num=x;}
	inline int get_func_number()	{return func_number;}
	virtual void set_func_number(int &x)	{func_number=x;}
	inline int get_func_count()	{return func_count;}
	inline void re_set_func_count()	{func_count=0;}
	virtual double real_func(Pop&a) {return 0.0;}
	virtual void func(Pop&a) {;}
	virtual void func(Gene **,const int& ) {;}
	virtual void func(Gene &) {;}
	virtual void pop_create(Pop &a) {;}
	virtual void set_func_count(const int &x) {func_count=x;}
	void sleep();
	void sleep(double);
};

#endif //_FUNC_CPP_H_



