//-------------------------------------------------------------------
// FILENAME    : ncga.h
// DESCRIPTION : Operating GA  of NCGA
//-------------------------------------------------------------------
#ifndef _NCGA_H_
#define _NCGA_H_

#include "oneisland.h"
#include "gene.h"
#include "pop.h"
#include "base.h"
#include "select_spea2.h"

#define ON 1
#define OFF 0

class Ncga : public One
{
 protected:
  static int pareto_count;
  static int child_num;
  static int send_count;
  static int what_times;
  static int obj_base;
  static double width_rate;
  Gene **tmpChild;
  Pop perfect_pop,next_pop;
  Select_spea2 select_spea2;
public:
  Ncga();
  virtual ~Ncga();
  virtual void pareto_creat();
  virtual void cycle();
  virtual void next_1_gene();
  virtual void initGA();
  virtual void initialize();
  virtual void f_output();
  void real_mcc_model();
  void sp_version();
  void ga_operator();
  virtual void selection();
  virtual void mutation();
  virtual void  function();
  virtual void  function(Pop &);
  virtual void all_open_w_file();
  virtual void all_open_file_close();
  void now_pop_re_create(Pop &now,Pop &perfect);
  void neighbor_mix(Gene **ap_gene,int first,int end);
};

#endif // _NCGA_H_



