//-------------------------------------------------------------------
// FILENAME    : one_nsga2.h
// DESCRIPTION : Operating GA  of NSGA-II
//-------------------------------------------------------------------
#ifndef _ONE_NSGA2_H_
#define _ONE_NSGA2_H_

#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include "base.h"
#include "oneisland.h"
#include "select_nsga2.h"

class One_nsga2 : public One
{
protected:
  Pop archive;
  Select_nsga2 select_nsga2;

 public:
  One_nsga2();
 virtual void initialize();
 void enviroment_selection();
 virtual void initGA();
 virtual void o_file();
 // virtual void enviroment_selection();

 virtual void selection();
 virtual void next_1_gene();
 virtual void f_output();
 virtual void f_set_output();
 virtual void all_open_w_file();
};
#endif //_ONE_NSGA2_H_




