#ifndef _POP_CPP_H_
#define _POP_CPP_H_

#include <stdlib.h>
#include <iostream>
#include "base.h"
#include "gene.h"

class Pop
{
  double *max_obj_value,*min_obj_value;
 protected:
  int pop_num;
  static int obj_num;
  static int max_pop;
  static int plan_num;

public:
  Gene **ap_gene;
	Pop();
	Pop(const Pop&);
	Pop(const int&);
	virtual ~Pop();
	double *avg_obj;
	double& set_max_obj(const int i) {return max_obj_value[i];}
	double& set_min_obj(const int i) {return min_obj_value[i];}
	inline int get_pop_num()	{return pop_num;}
	inline void set_pop_num(const int& x)	{pop_num=x;}
	inline void set_obj_num(const int& x)	{obj_num=x;}
	inline void set_plan_num(const int& x)	{plan_num=x;}
	inline int get_obj_num()	{return obj_num;}
	virtual Pop operator=(const Pop&);
	virtual Pop operator=(vector<Gene>& f);
	virtual Pop operator+=(const Pop&);
	virtual void copy(const Pop&);
	virtual void plus_copy(const Pop&,const int&);
	virtual void init_ap_gene(const int&);
	void show_pop();
	void show_pop_curent();
	void show_pop_detail();
	void f_show_obj(FILE *);
	void f_show_detail(FILE *);
	void flag_change_safe();
	void flag_change_out();
};

#endif //_POP_CPP_H_
