//-------------------------------------------------------------------
// FILENAME    : func_numberical.h
// DESCRIPTION : Function of Numerical function
//-------------------------------------------------------------------
#ifndef _FUNC_NUMERI_CPP_H_
#define _FUNC_NUMERI_CPP_H_

#include <iostream>
#include <stdlib.h>
#include <ctype.h>
#include "func.h"
#include "base.h"

#define SAFE 1
#define OUT 0
#define PI 3.1415


class Gene;
class Pop;

class Numerical_func : public Func
{
        void func1(Gene&);
        void func2(Gene&);
        void func3(Gene&);
        void func4(Gene&);
        void func5(Gene&);
        void func6(Gene&);
        void func7(Gene&);
        void func8(Gene&);
        void func9(Gene&);
        void func10(Gene&);
        void func11(Gene&);
        void func12(Gene&);
        void func13(Gene&);
        void func14(Gene&);
        void func15(Gene&);
        void func16(Gene&);

        double real_func1(Gene&);
        double real_func5(Gene&);
        double real_func10(Gene&);
        double real_func11(Gene&);
        double real_func12(Gene&);
        double real_func14(Gene&);
        double real_func15(Gene&);
        double real_func16(Gene&);
        
	mutable MTRand mtrand;
	inline double rand() const {return mtrand.genrand();}
        inline int rand_int(int n) const {return mtrand.genrand_int(n);}

public:
	virtual ~Numerical_func() { ;}
	virtual void func(Pop&);
	virtual void func(Gene **,const int& );
	virtual void func(Gene &);
	virtual void pop_create(Gene **,const int& );
	virtual void pop_create(Gene **ap_gene,const int first,const int end);
	virtual void pop_create(Pop &);
	virtual double real_func(Pop &);
	virtual void set_func_number(const int &x);
	virtual void set_func_number(const int &x,const int &y);
	virtual void set_func_number(const int &x,const int &y,const int &z);
};

#endif //_FUNC_NUMERI_CPP_H_


