//-------------------------------------------------------------------
// FILENAME    : mutation.cpp
// DESCRIPTION : Mutation
//-------------------------------------------------------------------
#include <iostream>
#include <stdio.h>
#include <math.h>
#include "mutation.h"
#include "gene.h"
#include "pop.h"

int Mutation::length=1;
double Mutation::mut_r=0.0;
int Mutation::mut_method=1;
int Mutation::pop_num=100;
int Mutation::plan_num=100;

void Mutation::mut(Pop &a)
{
  pop_num=a.get_pop_num();
  mut(a.ap_gene,pop_num);
}

void Mutation::mut(Gene **ap_gene,const int &num)
{
  int loop,i,j;
  double x,dum;	
  pop_num = num;
  for(i=0;i<pop_num;i++){
    for(j=0;j<length;j++){
      dum=genrand();
      if(mut_r>=dum)
		mutation_exe(*ap_gene[i],j);
      ap_gene[i]->change_flag=CHANGE;
    }
  }
}

void Mutation::mutation_exe(Gene &gene,const int &j)
{
  bit_reverse(gene,j);
}

void Mutation::bit_reverse(Gene &a,const int &j)
{
  if(a.get_locus(j)==1)
    a.get_locus(j)=0;
  else
    a.get_locus(j)=1;
}





