//-------------------------------------------------------------------
// FILENAME    : select_spea2.h
// DESCRIPTION : Selection for SPEA2
//-------------------------------------------------------------------
#ifndef _Select_SPEA2_CPP_H_
#define _Select_SPEA2_CPP_H_

#include <stdlib.h>
#include <stdio.h>
#include <vector>
#include "select.h"
#include "pop.h"


class Select_spea2 : public Select
{
  Pop R_t;
  static int obj_base;
  double distance_calcurate(Gene& a,Gene& b);
  void minimum_reserve_fix(Pop &a,vector<double>& reserve_number);
public: 
  Select_spea2();
  virtual ~Select_spea2();
  void select_spea2(Pop& P_t,Pop& Q_t);
  void select_spea2(Pop& P_t,const int& N);
  void fitness_assignment(Pop &P_t);
  void copy(Pop& R_t,Pop& Q_t);
  void copy(Pop& P_t,const int& N);
  void plus(Pop& R_t,Pop& Q_t,const int& N);
  void plus(Pop& R_t,const int& N);
  void truncation_operator(Pop &Q_t,const int& N);
  void crowding_distatnce_assignment(Pop &Q_t,const int& N);
};

struct S_q_list
{
  vector<int> domin;
};

#endif	//_Select_Spea2_CPP_H_

